int dimmung (long  time, long StartEin, long StartAus, long EndeEin, long EndeAus, int Min, int Max)
{
  // Starten der Dimmung von Min
  if (time >= StartEin  && time <= StartAus)
  {
    float m = ( Max - Min) /  100.0;
    float b = Max - m * 100.0;
    float y = m * ((time - StartEin) * 100.0 / (StartAus - StartEin)) + b;
    return y;
  }

  // Voll an keine Dimmung
  if (time > StartAus  && time < EndeEin)
     return Max;

  // Ende der Dimmung
  if (time >= EndeEin  && time <= EndeAus)
  {
    float m = ( Max - Min) /  100.0;
    float b = Max - m * 100.0;
    float y = m * ((EndeAus - time) * 100 / (EndeAus - EndeEin)) + b;
    return y;
  }
  return Min;
}

int dimmungPWM (long  time, long StartEin, long StartAus, long EndeEin, long EndeAus, int Min, int Max)
{
  
   Min = 4096 / 100 * Min;
   Max = 4096 / 100 * Max;
   
  // Starten der Dimmung von Min
  if (time >= StartEin  && time <= StartAus)
  {
    float m = ( Max - Min) /  100.0;
    float b = Max - m * 100.0;
    float y = m * ((time - StartEin) * 100 / (StartAus - StartEin)) + b;
    return y;
  }

  // Voll an keine Dimmung
  if (time > StartAus  && time < EndeEin)
     return Max;

  // Ende der Dimmung
  if (time >= EndeEin  && time <= EndeAus)
  {
    float m = ( Max - Min) /  100.0;
    float b = Max - m * 100.0;
    float y = m * ((EndeAus - time) * 100 / (EndeAus - EndeEin)) + b;
    return y;
  }

  // Der Rest
  return Min;
}


